<script setup lang="ts">
const { fetchPendingImageMetadata, reject, approve } = useImageService();
const { addMessage } = useSnackBarStore();
const { data, pending, error } = useAsyncData("image-review", () =>
  fetchPendingImageMetadata(),
);
const headers = [
  {
    title: "Pending Images",
    key: "item",
    value: (item: any) => item,
    sortable: false,
  },
];
const selectedItems = ref([] as string[]);
const count = computed(() => selectedItems.value.length);

const acceptLoading = ref(false);
const accept = async () => {
  if (count.value === 0) return;
  acceptLoading.value = true;
  try {
    await approve(selectedItems.value);
    addMessage({
      text: `${count.value} images accepted`,
      color: "success",
    });
    data.value =
      data.value?.filter((item) => !selectedItems.value.includes(item.id)) ||
      [];
    selectedItems.value = [];
  } catch {
    addMessage({ text: "Failed to accept images", color: "error" });
  } finally {
    acceptLoading.value = false;
  }
};

const deleteLoading = ref(false);
const delete_ = async () => {
  if (count.value === 0) return;
  deleteLoading.value = true;
  try {
    await reject(selectedItems.value);
    addMessage({
      text: `${count.value} images deleted`,
      color: "success",
    });
    data.value =
      data.value?.filter((item) => !selectedItems.value.includes(item.id)) ||
      [];
    selectedItems.value = [];
  } catch {
    addMessage({ text: "Failed to delete images", color: "error" });
  } finally {
    deleteLoading.value = false;
  }
};
</script>

<template>
  <AsyncView
    :error="error"
    :loading="pending"
    error-message="Failed to fetch image for review"
  >
    <v-data-table
      v-model="selectedItems"
      :items="data || []"
      :headers="headers"
      item-value="id"
      show-select
    >
      <template #item.item="{ item }">
        <ImageHolder
          :image-id="item.id"
          :status="item.status"
          :height="150"
          class="my-4"
        />
      </template>
    </v-data-table>
    <div class="mt-4">
      <v-btn
        color="success"
        variant="text"
        :loading="acceptLoading"
        @click="accept"
      >
        Accept all selected ({{ count }})
      </v-btn>
      <v-btn
        color="error"
        variant="text"
        :loading="deleteLoading"
        @click="delete_"
      >
        Delete all selected ({{ count }})</v-btn
      >
    </div>
  </AsyncView>
</template>
